//-----------------------------------------------------------------------------
// Generated with NVIDIA Nsight Graphics 2021.1.1.0
// 
// File: FrameSetup00.cpp
// 
//-----------------------------------------------------------------------------

#include <vector>
#include <sstream>

#include <GL/glew.h>
#include <GL/wglew.h>
#include <GL/wglext.h>

#include "OpenGLReplay.h"
#include "OpenGLHelpers.h"
#include "WGLHelpers.h"
#include "Helpers.h"
#include "ReplayHelpers.h"
#include "Resources.h"
#include "Application.h"

NV_REPLAY_BEGIN_FRAME_SETUP()

//-----------------------------------------------------------------------------
// SetInitialFrameState00
//-----------------------------------------------------------------------------
void SetInitialFrameState00()
{
    BEGIN_DATA_SCOPE_FUNCTION();

    // Switch to staging context
    NV_EXEC_GL(glFinish());
    MakeCurrent(hdc_000000001A010C7C, Context_uid_26_Staging);

    // Shader_uidof_34
    {
        BEGIN_DATA_SCOPE();

        {
            BEGIN_DATA_SCOPE();

            auto blobProxy = GetDatabase().Read<const GLchar*>({0});

            static const GLchar* pconstGLchar_temp_4 = blobProxy.Get();
            static const GLint constGLint_temp_4 = 199ull;
            NV_EXEC_GL(glShaderSource(Shader_uid_34, 1, &pconstGLchar_temp_4, &constGLint_temp_4));
        }

        NV_EXEC_GL(glCompileShader(Shader_uid_34));

        static GLint GLint_temp_6 = GL_ZERO;
        NV_EXEC_GL(glGetShaderiv(Shader_uid_34, GL_COMPILE_STATUS, &GLint_temp_6));

        NV_THROW_IF(!GLint_temp_6, "Failed to compile Shader_uid_34");
    }

    NV_CHECK_INIT(Shader_uid_34);

    // Shader_uidof_35
    {
        BEGIN_DATA_SCOPE();

        {
            BEGIN_DATA_SCOPE();

            auto blobProxy = GetDatabase().Read<const GLchar*>({1});

            static const GLchar* pconstGLchar_temp_5 = blobProxy.Get();
            static const GLint constGLint_temp_5 = 623ull;
            NV_EXEC_GL(glShaderSource(Shader_uid_35, 1, &pconstGLchar_temp_5, &constGLint_temp_5));
        }

        NV_EXEC_GL(glCompileShader(Shader_uid_35));

        static GLint GLint_temp_7 = GL_ZERO;
        NV_EXEC_GL(glGetShaderiv(Shader_uid_35, GL_COMPILE_STATUS, &GLint_temp_7));

        NV_THROW_IF(!GLint_temp_7, "Failed to compile Shader_uid_35");
    }

    NV_CHECK_INIT(Shader_uid_35);

    // Shader_uidof_37
    {
        BEGIN_DATA_SCOPE();

        {
            BEGIN_DATA_SCOPE();

            auto blobProxy = GetDatabase().Read<const GLchar*>({2});

            static const GLchar* pconstGLchar_temp_6 = blobProxy.Get();
            static const GLint constGLint_temp_6 = 30462ull;
            NV_EXEC_GL(glShaderSource(Shader_uid_37, 1, &pconstGLchar_temp_6, &constGLint_temp_6));
        }

        NV_EXEC_GL(glCompileShader(Shader_uid_37));

        static GLint GLint_temp_8 = GL_ZERO;
        NV_EXEC_GL(glGetShaderiv(Shader_uid_37, GL_COMPILE_STATUS, &GLint_temp_8));

        NV_THROW_IF(!GLint_temp_8, "Failed to compile Shader_uid_37");
    }

    NV_CHECK_INIT(Shader_uid_37);

    // Buffer_uidof_31
    {
        BEGIN_DATA_SCOPE();

        NV_EXEC_GL(glBindBuffer(GL_COPY_WRITE_BUFFER, Buffer_uid_31));
        NV_EXEC_GL(glBufferStorage(GL_COPY_WRITE_BUFFER, 48, NV_GET_RESOURCE(GLvoid*, 3), 0));
    }

    NV_CHECK_INIT(Buffer_uid_31);

    // Buffer_uidof_43
    {
        BEGIN_DATA_SCOPE();

        NV_EXEC_GL(glBindBuffer(GL_COPY_WRITE_BUFFER, Buffer_uid_43));
        NV_EXEC_GL(glBufferStorage(GL_COPY_WRITE_BUFFER, 288336, NULL, 0));
        NV_EXEC_GL(glBindBuffer(GL_COPY_READ_BUFFER, Buffer_uid_43_Staging));
        NV_EXEC_GL(glCopyBufferSubData(GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, 0, 0, 288336));
    }

    NV_CHECK_INIT(Buffer_uid_43);

    // Buffer_uidof_39
    {
        BEGIN_DATA_SCOPE();

        NV_EXEC_GL(glBindBuffer(GL_COPY_WRITE_BUFFER, Buffer_uid_39));

        // Buffer had size of zero at capture begin
        NV_EXEC_GL(glBufferData(GL_COPY_WRITE_BUFFER, 0, NULL, GL_STATIC_DRAW));
    }

    NV_CHECK_INIT(Buffer_uid_39);

    // Buffer_uidof_40
    {
        BEGIN_DATA_SCOPE();

        NV_EXEC_GL(glBindBuffer(GL_COPY_WRITE_BUFFER, Buffer_uid_40));
        NV_EXEC_GL(glBufferStorage(GL_COPY_WRITE_BUFFER, 424800, NULL, 0));
        NV_EXEC_GL(glBindBuffer(GL_COPY_READ_BUFFER, Buffer_uid_40_Staging));
        NV_EXEC_GL(glCopyBufferSubData(GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, 0, 0, 424800));
    }

    NV_CHECK_INIT(Buffer_uid_40);

    // Buffer_uidof_41
    {
        BEGIN_DATA_SCOPE();

        NV_EXEC_GL(glBindBuffer(GL_COPY_WRITE_BUFFER, Buffer_uid_41));

        // Buffer had size of zero at capture begin
        NV_EXEC_GL(glBufferData(GL_COPY_WRITE_BUFFER, 0, NULL, GL_STATIC_DRAW));
    }

    NV_CHECK_INIT(Buffer_uid_41);

    // Buffer_uidof_42
    {
        BEGIN_DATA_SCOPE();

        NV_EXEC_GL(glBindBuffer(GL_COPY_WRITE_BUFFER, Buffer_uid_42));
        NV_EXEC_GL(glBufferStorage(GL_COPY_WRITE_BUFFER, 48, NULL, 0));
        NV_EXEC_GL(glBindBuffer(GL_COPY_READ_BUFFER, Buffer_uid_42_Staging));
        NV_EXEC_GL(glCopyBufferSubData(GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, 0, 0, 48));
    }

    NV_CHECK_INIT(Buffer_uid_42);

    // Buffer_uidof_30
    {
        BEGIN_DATA_SCOPE();

        NV_EXEC_GL(glBindBuffer(GL_COPY_WRITE_BUFFER, Buffer_uid_30));
        NV_EXEC_GL(glBufferStorage(GL_COPY_WRITE_BUFFER, 72, NV_GET_RESOURCE(GLvoid*, 4), 0));
    }

    NV_CHECK_INIT(Buffer_uid_30);

    // Texture_uidof_32
    {
        BEGIN_DATA_SCOPE();

        NV_EXEC_GL(glActiveTexture(GL_TEXTURE0));
        NV_EXEC_GL(glBindTexture(GL_TEXTURE_2D, Texture_uid_32));
        NV_EXEC_GL(glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR));
        NV_EXEC_GL(glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE));
        NV_EXEC_GL(glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE));
    }

    // Data for Texture_uidof_32
    {
        BEGIN_DATA_SCOPE();

        NV_EXEC_GL(glActiveTexture(GL_TEXTURE0));
        NV_EXEC_GL(glBindTexture(GL_TEXTURE_2D, Texture_uid_32));
        NV_EXEC_GL(glTexStorage2D(GL_TEXTURE_2D, 1, GL_RGBA32F, 1280, 720));
        NV_EXEC_GL(glBindFramebuffer(GL_READ_FRAMEBUFFER, Texture_uid_32_Staging_Read_Framebuffer));
        NV_EXEC_GL(glBindFramebuffer(GL_DRAW_FRAMEBUFFER, Texture_uid_32_Staging_Draw_Framebuffer));
        NV_EXEC_GL(glFramebufferTexture2D(GL_READ_FRAMEBUFFER, GL_COLOR_ATTACHMENT0, GL_TEXTURE_2D, Texture_uid_32_Staging, 0u));
        NV_EXEC_GL(glFramebufferTexture2D(GL_DRAW_FRAMEBUFFER, GL_COLOR_ATTACHMENT0, GL_TEXTURE_2D, Texture_uid_32, 0u));
        NV_EXEC_GL(glBindTexture(GL_TEXTURE_2D, Texture_uid_32_Staging));
        NV_EXEC_GL(glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_BASE_LEVEL, 0u));
        NV_EXEC_GL(glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAX_LEVEL, 0u));
        NV_EXEC_GL(glBindTexture(GL_TEXTURE_2D, Texture_uid_32));
        NV_EXEC_GL(glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_BASE_LEVEL, 0u));
        NV_EXEC_GL(glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAX_LEVEL, 0u));
        NV_EXEC_GL(glBlitFramebuffer(0, 0, 1280, 720, 0, 0, 1280, 720, GL_COLOR_BUFFER_BIT, GL_LINEAR));
        NV_EXEC_GL(glBindTexture(GL_TEXTURE_2D, Texture_uid_32_Staging));
        NV_EXEC_GL(glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_BASE_LEVEL, 0u));
        NV_EXEC_GL(glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAX_LEVEL, 1000u));
        NV_EXEC_GL(glBindTexture(GL_TEXTURE_2D, Texture_uid_32));
        NV_EXEC_GL(glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_BASE_LEVEL, 0u));
        NV_EXEC_GL(glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAX_LEVEL, 1000u));
    }

    NV_CHECK_INIT(Texture_uid_32);

    // Program_uidof_36
    {
        BEGIN_DATA_SCOPE();

        // Attach Shader_uid_34
        NV_EXEC_GL(glAttachShader(Program_uid_36, Shader_uid_34));

        // Attach Shader_uid_35
        NV_EXEC_GL(glAttachShader(Program_uid_36, Shader_uid_35));

        // Set linked bound attribute locations
        {
            BEGIN_DATA_SCOPE();

            NV_EXEC_GL(glBindAttribLocation(Program_uid_36, 0u, "pos"));
            NV_EXEC_GL(glBindAttribLocation(Program_uid_36, 1u, "uvs"));
        }

        // Switch to rendering context
        MakeCurrent(hdc_000000001A010C7C, Context_uid_26);
        NV_EXEC_GL(glLinkProgram(Program_uid_36));

        // Switch to staging context
        NV_EXEC_GL(glFinish());
        MakeCurrent(hdc_000000001A010C7C, Context_uid_26_Staging);

        static GLint GLint_temp_9 = GL_ZERO;
        NV_EXEC_GL(glGetProgramiv(Program_uid_36, GL_LINK_STATUS, &GLint_temp_9));

        NV_THROW_IF(!GLint_temp_9, "Failed to link program Program_uid_36");

        // Detach pre-existing shaders that were linked
        {
            BEGIN_DATA_SCOPE();

            // Detach Shader_uidof_34
            NV_EXEC_GL(glDetachShader(Program_uid_36, Shader_uid_34));

            // Detach Shader_uidof_35
            NV_EXEC_GL(glDetachShader(Program_uid_36, Shader_uid_35));
        }

        // Attach or detach shaders
        {
            BEGIN_DATA_SCOPE();

            // Attach Shader_uidof_34
            NV_EXEC_GL(glAttachShader(Program_uid_36, Shader_uid_34));

            // Attach Shader_uidof_35
            NV_EXEC_GL(glAttachShader(Program_uid_36, Shader_uid_35));
        }

        // Query program variable locations
        {
            BEGIN_DATA_SCOPE();

            // Query uniforms for Program_uidof_36
            {
                BEGIN_DATA_SCOPE();

                Uniform_prog_3_loc_0 = glGetUniformLocation(Program_uid_36, "tex");
            }
        }

        // Set uniform values
        {
            BEGIN_DATA_SCOPE();

            NV_EXEC_GL(glUseProgram(Program_uid_36));
            NV_EXEC_GL(glUniform1i(Uniform_prog_3_loc_0, 0));
        }
    }

    NV_CHECK_INIT(Program_uid_36);

    // Program_uidof_38
    {
        BEGIN_DATA_SCOPE();

        // Attach Shader_uid_37
        NV_EXEC_GL(glAttachShader(Program_uid_38, Shader_uid_37));

        // Switch to rendering context
        MakeCurrent(hdc_000000001A010C7C, Context_uid_26);
        NV_EXEC_GL(glLinkProgram(Program_uid_38));

        // Switch to staging context
        NV_EXEC_GL(glFinish());
        MakeCurrent(hdc_000000001A010C7C, Context_uid_26_Staging);

        static GLint GLint_temp_10 = GL_ZERO;
        NV_EXEC_GL(glGetProgramiv(Program_uid_38, GL_LINK_STATUS, &GLint_temp_10));

        NV_THROW_IF(!GLint_temp_10, "Failed to link program Program_uid_38");

        // Detach pre-existing shaders that were linked
        {
            BEGIN_DATA_SCOPE();

            // Detach Shader_uidof_37
            NV_EXEC_GL(glDetachShader(Program_uid_38, Shader_uid_37));
        }

        // Attach or detach shaders
        {
            BEGIN_DATA_SCOPE();

            // Attach Shader_uidof_37
            NV_EXEC_GL(glAttachShader(Program_uid_38, Shader_uid_37));
        }

        // Query program variable locations
        {
            BEGIN_DATA_SCOPE();

            // Query uniforms for Program_uidof_38
            {
                BEGIN_DATA_SCOPE();

                Uniform_prog_5_loc_0 = glGetUniformLocation(Program_uid_38, "screen");
                Uniform_prog_5_loc_1 = glGetUniformLocation(Program_uid_38, "u_frame_data");
            }

            // Query shader storage block indices for Program_uidof_38
            {
                BEGIN_DATA_SCOPE();

                ShaderStorageBlock_prog_5_loc_0 = glGetProgramResourceIndex(Program_uid_38, GL_SHADER_STORAGE_BLOCK, "BVHSSBO");
                ShaderStorageBlock_prog_5_loc_1 = glGetProgramResourceIndex(Program_uid_38, GL_SHADER_STORAGE_BLOCK, "MaterialsSSBO");
                ShaderStorageBlock_prog_5_loc_2 = glGetProgramResourceIndex(Program_uid_38, GL_SHADER_STORAGE_BLOCK, "ModelLightTrisSSBO");
                ShaderStorageBlock_prog_5_loc_3 = glGetProgramResourceIndex(Program_uid_38, GL_SHADER_STORAGE_BLOCK, "ModelTrisSSBO");
                ShaderStorageBlock_prog_5_loc_4 = glGetProgramResourceIndex(Program_uid_38, GL_SHADER_STORAGE_BLOCK, "SpheresSSBO");
            }
        }

        // Set shader storage block buffer bindings
        {
            BEGIN_DATA_SCOPE();

            NV_EXEC_GL(glShaderStorageBlockBinding(Program_uid_38, ShaderStorageBlock_prog_5_loc_0, 4));
            NV_EXEC_GL(glShaderStorageBlockBinding(Program_uid_38, ShaderStorageBlock_prog_5_loc_1, 3));
            NV_EXEC_GL(glShaderStorageBlockBinding(Program_uid_38, ShaderStorageBlock_prog_5_loc_2, 2));
            NV_EXEC_GL(glShaderStorageBlockBinding(Program_uid_38, ShaderStorageBlock_prog_5_loc_3, 1));
            NV_EXEC_GL(glShaderStorageBlockBinding(Program_uid_38, ShaderStorageBlock_prog_5_loc_4, 0));
        }

        // Set uniform values
        {
            BEGIN_DATA_SCOPE();

            NV_EXEC_GL(glUseProgram(Program_uid_38));
            NV_EXEC_GL(glUniform1i(Uniform_prog_5_loc_0, 0));
            NV_EXEC_GL(glUniform2ui(Uniform_prog_5_loc_1, 1635724276u, 195u));
        }
    }

    NV_CHECK_INIT(Program_uid_38);

    // Switch to rendering context
    NV_EXEC_GL(glFinish());
    MakeCurrent(hdc_000000001A010C7C, Context_uid_26);

    // VertexArray_uidof_29
    {
        BEGIN_DATA_SCOPE();

        NV_EXEC_GL(glBindVertexArray(VertexArray_uid_29));
        NV_EXEC_GL(glBindBuffer(GL_ARRAY_BUFFER, Buffer_uid_30));
        NV_EXEC_GL(glVertexAttribPointer(0u, 3, GL_FLOAT, GL_FALSE, 12, (GLvoid*)0x0));
        NV_EXEC_GL(glEnableVertexAttribArray(0u));
        NV_EXEC_GL(glVertexAttribDivisor(0u, 0));
        NV_EXEC_GL(glBindBuffer(GL_ARRAY_BUFFER, Buffer_uid_31));
        NV_EXEC_GL(glVertexAttribPointer(1u, 2, GL_FLOAT, GL_FALSE, 8, (GLvoid*)0x0));
        NV_EXEC_GL(glEnableVertexAttribArray(1u));
        NV_EXEC_GL(glVertexAttribDivisor(1u, 0));
    }

    NV_CHECK_INIT(VertexArray_uid_29);
    NV_CHECK_INIT(TransformFeedback_uid_27);
    NV_CHECK_INIT(VertexArray_uid_28);

    // OpenGL_Context_uidof_26
    {
        BEGIN_DATA_SCOPE();

        // Patch
        {
            BEGIN_DATA_SCOPE();

            glPatchParameteri(GL_PATCH_VERTICES, 3);

            static float float_temp_3[4] = { HexToFloat(0x3F800000/*1.0f*/), HexToFloat(0x3F800000/*1.0f*/), HexToFloat(0x3F800000/*1.0f*/), HexToFloat(0x3F800000/*1.0f*/) };
            glPatchParameterfv(GL_PATCH_DEFAULT_OUTER_LEVEL, float_temp_3);

            static float float_temp_4[2] = { HexToFloat(0x3F800000/*1.0f*/), HexToFloat(0x3F800000/*1.0f*/) };
            glPatchParameterfv(GL_PATCH_DEFAULT_INNER_LEVEL, float_temp_4);
        }

        // Vertex Array
        {
            BEGIN_DATA_SCOPE();

            glBindBuffer(GL_ARRAY_BUFFER, Buffer_uid_31);
            glDisableClientState(GL_DRAW_INDIRECT_UNIFIED_NV);
            glBindVertexArray(VertexArray_uid_29);
            glBindBuffer(GL_PARAMETER_BUFFER, 0);
            glDisable(GL_PRIMITIVE_RESTART);
            glPrimitiveRestartIndex(0);
            glDisable(GL_PRIMITIVE_RESTART_FIXED_INDEX);
        }

        // Transformation
        {
            BEGIN_DATA_SCOPE();

            glViewportIndexedf(0, 0.0f, 0.0f, HexToFloat(0x44A00000/*1280.0f*/), HexToFloat(0x44340000/*720.0f*/));
            glDepthRangeIndexed(0, 0.0, HexToDouble(0x3FF0000000000000/*1.0*/));
            glViewportIndexedf(1, 0.0f, 0.0f, HexToFloat(0x44A00000/*1280.0f*/), HexToFloat(0x44340000/*720.0f*/));
            glDepthRangeIndexed(1, 0.0, HexToDouble(0x3FF0000000000000/*1.0*/));
            glViewportIndexedf(2, 0.0f, 0.0f, HexToFloat(0x44A00000/*1280.0f*/), HexToFloat(0x44340000/*720.0f*/));
            glDepthRangeIndexed(2, 0.0, HexToDouble(0x3FF0000000000000/*1.0*/));
            glViewportIndexedf(3, 0.0f, 0.0f, HexToFloat(0x44A00000/*1280.0f*/), HexToFloat(0x44340000/*720.0f*/));
            glDepthRangeIndexed(3, 0.0, HexToDouble(0x3FF0000000000000/*1.0*/));
            glViewportIndexedf(4, 0.0f, 0.0f, HexToFloat(0x44A00000/*1280.0f*/), HexToFloat(0x44340000/*720.0f*/));
            glDepthRangeIndexed(4, 0.0, HexToDouble(0x3FF0000000000000/*1.0*/));
            glViewportIndexedf(5, 0.0f, 0.0f, HexToFloat(0x44A00000/*1280.0f*/), HexToFloat(0x44340000/*720.0f*/));
            glDepthRangeIndexed(5, 0.0, HexToDouble(0x3FF0000000000000/*1.0*/));
            glViewportIndexedf(6, 0.0f, 0.0f, HexToFloat(0x44A00000/*1280.0f*/), HexToFloat(0x44340000/*720.0f*/));
            glDepthRangeIndexed(6, 0.0, HexToDouble(0x3FF0000000000000/*1.0*/));
            glViewportIndexedf(7, 0.0f, 0.0f, HexToFloat(0x44A00000/*1280.0f*/), HexToFloat(0x44340000/*720.0f*/));
            glDepthRangeIndexed(7, 0.0, HexToDouble(0x3FF0000000000000/*1.0*/));
            glViewportIndexedf(8, 0.0f, 0.0f, HexToFloat(0x44A00000/*1280.0f*/), HexToFloat(0x44340000/*720.0f*/));
            glDepthRangeIndexed(8, 0.0, HexToDouble(0x3FF0000000000000/*1.0*/));
            glViewportIndexedf(9, 0.0f, 0.0f, HexToFloat(0x44A00000/*1280.0f*/), HexToFloat(0x44340000/*720.0f*/));
            glDepthRangeIndexed(9, 0.0, HexToDouble(0x3FF0000000000000/*1.0*/));
            glViewportIndexedf(10, 0.0f, 0.0f, HexToFloat(0x44A00000/*1280.0f*/), HexToFloat(0x44340000/*720.0f*/));
            glDepthRangeIndexed(10, 0.0, HexToDouble(0x3FF0000000000000/*1.0*/));
            glViewportIndexedf(11, 0.0f, 0.0f, HexToFloat(0x44A00000/*1280.0f*/), HexToFloat(0x44340000/*720.0f*/));
            glDepthRangeIndexed(11, 0.0, HexToDouble(0x3FF0000000000000/*1.0*/));
            glViewportIndexedf(12, 0.0f, 0.0f, HexToFloat(0x44A00000/*1280.0f*/), HexToFloat(0x44340000/*720.0f*/));
            glDepthRangeIndexed(12, 0.0, HexToDouble(0x3FF0000000000000/*1.0*/));
            glViewportIndexedf(13, 0.0f, 0.0f, HexToFloat(0x44A00000/*1280.0f*/), HexToFloat(0x44340000/*720.0f*/));
            glDepthRangeIndexed(13, 0.0, HexToDouble(0x3FF0000000000000/*1.0*/));
            glViewportIndexedf(14, 0.0f, 0.0f, HexToFloat(0x44A00000/*1280.0f*/), HexToFloat(0x44340000/*720.0f*/));
            glDepthRangeIndexed(14, 0.0, HexToDouble(0x3FF0000000000000/*1.0*/));
            glViewportIndexedf(15, 0.0f, 0.0f, HexToFloat(0x44A00000/*1280.0f*/), HexToFloat(0x44340000/*720.0f*/));
            glDepthRangeIndexed(15, 0.0, HexToDouble(0x3FF0000000000000/*1.0*/));
            glDisable(GL_VIEWPORT_POSITION_W_SCALE_NV);
            glViewportPositionWScaleNV(0, 0.0f, 0.0f);
            glViewportPositionWScaleNV(1, 0.0f, 0.0f);
            glViewportPositionWScaleNV(2, 0.0f, 0.0f);
            glViewportPositionWScaleNV(3, 0.0f, 0.0f);
            glViewportPositionWScaleNV(4, 0.0f, 0.0f);
            glViewportPositionWScaleNV(5, 0.0f, 0.0f);
            glViewportPositionWScaleNV(6, 0.0f, 0.0f);
            glViewportPositionWScaleNV(7, 0.0f, 0.0f);
            glViewportPositionWScaleNV(8, 0.0f, 0.0f);
            glViewportPositionWScaleNV(9, 0.0f, 0.0f);
            glViewportPositionWScaleNV(10, 0.0f, 0.0f);
            glViewportPositionWScaleNV(11, 0.0f, 0.0f);
            glViewportPositionWScaleNV(12, 0.0f, 0.0f);
            glViewportPositionWScaleNV(13, 0.0f, 0.0f);
            glViewportPositionWScaleNV(14, 0.0f, 0.0f);
            glViewportPositionWScaleNV(15, 0.0f, 0.0f);
            glDisable(GL_CLIP_DISTANCE0);
            glDisable(GL_CLIP_DISTANCE1);
            glDisable(GL_CLIP_DISTANCE2);
            glDisable(GL_CLIP_DISTANCE3);
            glDisable(GL_CLIP_DISTANCE4);
            glDisable(GL_CLIP_DISTANCE5);
            glDisable(GL_CLIP_DISTANCE0+6);
            glDisable(GL_CLIP_DISTANCE0+7);
            glDisable(GL_DEPTH_CLAMP);
            glBindTransformFeedback(GL_TRANSFORM_FEEDBACK, TransformFeedback_uid_27);
            glClipControl(36001u, 37726u);
        }

        // Coloring
        {
            BEGIN_DATA_SCOPE();

            glClampColor(GL_CLAMP_READ_COLOR, GL_FIXED_ONLY);
            glProvokingVertex(GL_LAST_VERTEX_CONVENTION);
        }

        // Rasterization
        {
            BEGIN_DATA_SCOPE();

            glDisable(GL_RASTERIZER_DISCARD);
            glPointSize(HexToFloat(0x3F800000/*1.0f*/));
            glPointParameterf(GL_POINT_FADE_THRESHOLD_SIZE, HexToFloat(0x3F800000/*1.0f*/));
            glPointParameteri(GL_POINT_SPRITE_COORD_ORIGIN, GL_UPPER_LEFT);
            glLineWidth(HexToFloat(0x3F800000/*1.0f*/));
            glDisable(GL_LINE_SMOOTH);
            glDisable(GL_CULL_FACE);
            glCullFace(GL_BACK);
            glFrontFace(GL_CCW);
            glDisable(GL_POLYGON_SMOOTH);
            glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
            glPolygonOffset(0.0f, 0.0f);
            glDisable(GL_POLYGON_OFFSET_POINT);
            glDisable(GL_POLYGON_OFFSET_LINE);
            glDisable(GL_POLYGON_OFFSET_FILL);

            // Extension
            {
                BEGIN_DATA_SCOPE();

                glDisable(GL_CONSERVATIVE_RASTERIZATION_NV);
                glSubpixelPrecisionBiasNV(0u, 0u);
                glDisable(GL_RASTER_MULTISAMPLE_EXT);
                glRasterSamplesEXT(0u, 0);
                glPolygonOffsetClamp(0.0f, 0.0f, 0.0f);
            }
        }

        // Multisampling
        {
            BEGIN_DATA_SCOPE();

            glEnable(GL_MULTISAMPLE);
            glDisable(GL_SAMPLE_ALPHA_TO_COVERAGE);
            glDisable(GL_SAMPLE_ALPHA_TO_ONE);
            glDisable(GL_SAMPLE_COVERAGE);
            glSampleCoverage(HexToFloat(0x3F800000/*1.0f*/), 0);
            glDisable(GL_SAMPLE_SHADING);
            glMinSampleShadingARB(0.0f);
            glDisable(GL_SAMPLE_MASK);
            glSampleMaski(0, 0xFFFFFFFFu);
            glSampleMaski(1, 0xFFFFFFFFu);
            glAlphaToCoverageDitherControlNV(37709u);
        }

        // Texture Units
        {
            BEGIN_DATA_SCOPE();

            glActiveTexture(GL_TEXTURE0);
            glBindTexture(GL_TEXTURE_2D, Texture_uid_32);
            glActiveTexture(GL_TEXTURE0);
        }

        // Texture
        {
            BEGIN_DATA_SCOPE();

            glActiveTexture(GL_TEXTURE0);
        }

        // Pixel Operations
        {
            BEGIN_DATA_SCOPE();

            glDisablei(GL_SCISSOR_TEST, 0);
            glScissorIndexed(0, 0, 0, 1280, 720);
            glDisablei(GL_SCISSOR_TEST, 1);
            glScissorIndexed(1, 0, 0, 1280, 720);
            glDisablei(GL_SCISSOR_TEST, 2);
            glScissorIndexed(2, 0, 0, 1280, 720);
            glDisablei(GL_SCISSOR_TEST, 3);
            glScissorIndexed(3, 0, 0, 1280, 720);
            glDisablei(GL_SCISSOR_TEST, 4);
            glScissorIndexed(4, 0, 0, 1280, 720);
            glDisablei(GL_SCISSOR_TEST, 5);
            glScissorIndexed(5, 0, 0, 1280, 720);
            glDisablei(GL_SCISSOR_TEST, 6);
            glScissorIndexed(6, 0, 0, 1280, 720);
            glDisablei(GL_SCISSOR_TEST, 7);
            glScissorIndexed(7, 0, 0, 1280, 720);
            glDisablei(GL_SCISSOR_TEST, 8);
            glScissorIndexed(8, 0, 0, 1280, 720);
            glDisablei(GL_SCISSOR_TEST, 9);
            glScissorIndexed(9, 0, 0, 1280, 720);
            glDisablei(GL_SCISSOR_TEST, 10);
            glScissorIndexed(10, 0, 0, 1280, 720);
            glDisablei(GL_SCISSOR_TEST, 11);
            glScissorIndexed(11, 0, 0, 1280, 720);
            glDisablei(GL_SCISSOR_TEST, 12);
            glScissorIndexed(12, 0, 0, 1280, 720);
            glDisablei(GL_SCISSOR_TEST, 13);
            glScissorIndexed(13, 0, 0, 1280, 720);
            glDisablei(GL_SCISSOR_TEST, 14);
            glScissorIndexed(14, 0, 0, 1280, 720);
            glDisablei(GL_SCISSOR_TEST, 15);
            glScissorIndexed(15, 0, 0, 1280, 720);
            glDisable(GL_STENCIL_TEST);
            glStencilFuncSeparate(GL_FRONT, GL_ALWAYS, 0u, 4294967295u);
            glStencilOpSeparate(GL_FRONT, GL_KEEP, GL_KEEP, GL_KEEP);
            glStencilFuncSeparate(GL_BACK, 519, 0u, 4294967295u);
            glStencilOpSeparate(GL_BACK, GL_KEEP, GL_KEEP, GL_KEEP);
            glDisable(GL_DEPTH_TEST);
            glDisable(GL_DEPTH_BOUNDS_TEST_EXT);
            glDepthBoundsEXT(0.0, HexToDouble(0x3FF0000000000000/*1.0*/));
            glDepthFunc(GL_LESS);
            glDisablei(GL_BLEND, 0);
            glBlendEquationi(0, GL_FUNC_ADD);
            glBlendFuncSeparateiARB(0, GL_ONE, GL_ZERO, GL_ONE, GL_ZERO);
            glDisablei(GL_BLEND, 1);
            glBlendEquationi(1, GL_FUNC_ADD);
            glBlendFuncSeparateiARB(1, GL_ONE, GL_ZERO, GL_ONE, GL_ZERO);
            glDisablei(GL_BLEND, 2);
            glBlendEquationi(2, GL_FUNC_ADD);
            glBlendFuncSeparateiARB(2, GL_ONE, GL_ZERO, GL_ONE, GL_ZERO);
            glDisablei(GL_BLEND, 3);
            glBlendEquationi(3, GL_FUNC_ADD);
            glBlendFuncSeparateiARB(3, GL_ONE, GL_ZERO, GL_ONE, GL_ZERO);
            glDisablei(GL_BLEND, 4);
            glBlendEquationi(4, GL_FUNC_ADD);
            glBlendFuncSeparateiARB(4, GL_ONE, GL_ZERO, GL_ONE, GL_ZERO);
            glDisablei(GL_BLEND, 5);
            glBlendEquationi(5, GL_FUNC_ADD);
            glBlendFuncSeparateiARB(5, GL_ONE, GL_ZERO, GL_ONE, GL_ZERO);
            glDisablei(GL_BLEND, 6);
            glBlendEquationi(6, GL_FUNC_ADD);
            glBlendFuncSeparateiARB(6, GL_ONE, GL_ZERO, GL_ONE, GL_ZERO);
            glDisablei(GL_BLEND, 7);
            glBlendEquationi(7, GL_FUNC_ADD);
            glBlendFuncSeparateiARB(7, GL_ONE, GL_ZERO, GL_ONE, GL_ZERO);
            glBlendColor(0.0f, 0.0f, 0.0f, 0.0f);
            glDisable(GL_FRAMEBUFFER_SRGB);
            glEnable(GL_DITHER);
            glDisable(GL_COLOR_LOGIC_OP);
            glLogicOp(GL_COPY);
        }

        // Framebuffer Control
        {
            BEGIN_DATA_SCOPE();

            glColorMaski(0, 1, 1, 1, 1);
            glColorMaski(1, 1, 1, 1, 1);
            glColorMaski(2, 1, 1, 1, 1);
            glColorMaski(3, 1, 1, 1, 1);
            glColorMaski(4, 1, 1, 1, 1);
            glColorMaski(5, 1, 1, 1, 1);
            glColorMaski(6, 1, 1, 1, 1);
            glColorMaski(7, 1, 1, 1, 1);
            glDepthMask(GL_TRUE);
            glStencilMaskSeparate(GL_FRONT, -1);
            glStencilMaskSeparate(GL_BACK, -1);
            glClearColor(HexToFloat(0x3E4CCCCD/*0.2f*/), HexToFloat(0x3E4CCCCD/*0.2f*/), HexToFloat(0x3E4CCCCD/*0.2f*/), HexToFloat(0x3F800000/*1.0f*/));
            glClearDepth(HexToDouble(0x3FF0000000000000/*1.0*/));
            glClearStencil(0);
        }

        // Framebuffers
        {
            BEGIN_DATA_SCOPE();

            glBindFramebuffer(GL_DRAW_FRAMEBUFFER, 0);
            glBindFramebuffer(GL_READ_FRAMEBUFFER, 0);
        }

        // Pixels
        {
            BEGIN_DATA_SCOPE();

            glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
            glPixelStorei(GL_PACK_ALIGNMENT, 4);
            glPixelStorei(GL_UNPACK_SWAP_BYTES, 0);
            glPixelStorei(GL_UNPACK_LSB_FIRST, 0);
            glPixelStorei(GL_UNPACK_IMAGE_HEIGHT, 0);
            glPixelStorei(GL_UNPACK_SKIP_IMAGES, 0);
            glPixelStorei(GL_UNPACK_ROW_LENGTH, 0);
            glPixelStorei(GL_UNPACK_SKIP_ROWS, 0);
            glPixelStorei(GL_UNPACK_SKIP_PIXELS, 0);
            glPixelStorei(GL_UNPACK_COMPRESSED_BLOCK_WIDTH, 0);
            glPixelStorei(GL_UNPACK_COMPRESSED_BLOCK_HEIGHT, 0);
            glPixelStorei(GL_UNPACK_COMPRESSED_BLOCK_DEPTH, 0);
            glPixelStorei(GL_UNPACK_COMPRESSED_BLOCK_SIZE, 0);
            glPixelStorei(GL_PACK_SWAP_BYTES, 0);
            glPixelStorei(GL_PACK_LSB_FIRST, 0);
            glPixelStorei(GL_PACK_IMAGE_HEIGHT, 0);
            glPixelStorei(GL_PACK_SKIP_IMAGES, 0);
            glPixelStorei(GL_PACK_ROW_LENGTH, 0);
            glPixelStorei(GL_PACK_SKIP_ROWS, 0);
            glPixelStorei(GL_PACK_SKIP_PIXELS, 0);
            glPixelStorei(GL_PACK_COMPRESSED_BLOCK_WIDTH, 0);
            glPixelStorei(GL_PACK_COMPRESSED_BLOCK_HEIGHT, 0);
            glPixelStorei(GL_PACK_COMPRESSED_BLOCK_DEPTH, 0);
            glPixelStorei(GL_PACK_COMPRESSED_BLOCK_SIZE, 0);
        }

        // Program Bindings
        {
            BEGIN_DATA_SCOPE();

            glUseProgram(Program_uid_36);
            glBindProgramPipeline(0);
        }

        // Uniform Buffers
        {
            BEGIN_DATA_SCOPE();

            glDisableClientState(GL_UNIFORM_BUFFER_UNIFIED_NV);
        }

        // Vertex And Geometry Shader State
        {
            BEGIN_DATA_SCOPE();

            glVertexAttrib4f(0, 0.0f, 0.0f, 0.0f, HexToFloat(0x3F800000/*1.0f*/));
            glVertexAttrib4f(1, 0.0f, 0.0f, 0.0f, HexToFloat(0x3F800000/*1.0f*/));
            glVertexAttrib4f(2, 0.0f, 0.0f, 0.0f, HexToFloat(0x3F800000/*1.0f*/));
            glVertexAttrib4f(3, 0.0f, 0.0f, 0.0f, HexToFloat(0x3F800000/*1.0f*/));
            glVertexAttrib4f(4, 0.0f, 0.0f, 0.0f, HexToFloat(0x3F800000/*1.0f*/));
            glVertexAttrib4f(5, 0.0f, 0.0f, 0.0f, HexToFloat(0x3F800000/*1.0f*/));
            glVertexAttrib4f(6, 0.0f, 0.0f, 0.0f, HexToFloat(0x3F800000/*1.0f*/));
            glVertexAttrib4f(7, 0.0f, 0.0f, 0.0f, HexToFloat(0x3F800000/*1.0f*/));
            glVertexAttrib4f(8, 0.0f, 0.0f, 0.0f, HexToFloat(0x3F800000/*1.0f*/));
            glVertexAttrib4f(9, 0.0f, 0.0f, 0.0f, HexToFloat(0x3F800000/*1.0f*/));
            glVertexAttrib4f(10, 0.0f, 0.0f, 0.0f, HexToFloat(0x3F800000/*1.0f*/));
            glVertexAttrib4f(11, 0.0f, 0.0f, 0.0f, HexToFloat(0x3F800000/*1.0f*/));
            glVertexAttrib4f(12, 0.0f, 0.0f, 0.0f, HexToFloat(0x3F800000/*1.0f*/));
            glVertexAttrib4f(13, 0.0f, 0.0f, 0.0f, HexToFloat(0x3F800000/*1.0f*/));
            glVertexAttrib4f(14, 0.0f, 0.0f, 0.0f, HexToFloat(0x3F800000/*1.0f*/));
            glVertexAttrib4f(15, 0.0f, 0.0f, 0.0f, HexToFloat(0x3F800000/*1.0f*/));
            glDisable(GL_VERTEX_PROGRAM_POINT_SIZE);
        }

        // Image Units
        {
            BEGIN_DATA_SCOPE();

            glBindImageTexture(0, Texture_uid_32, 0u, GL_FALSE, 0, GL_READ_WRITE, GL_RGBA32F);
        }

        // Shader Storage Buffers
        {
            BEGIN_DATA_SCOPE();

            glBindBufferBase(GL_SHADER_STORAGE_BUFFER, 1, Buffer_uid_40);
            glBindBufferBase(GL_SHADER_STORAGE_BUFFER, 3, Buffer_uid_42);
            glBindBufferBase(GL_SHADER_STORAGE_BUFFER, 4, Buffer_uid_43);
        }

        // Buffer Object Bindings
        {
            BEGIN_DATA_SCOPE();

            glBindBuffer(GL_ATOMIC_COUNTER_BUFFER, 0);
            glBindBuffer(GL_TRANSFORM_FEEDBACK_BUFFER, 0);
            glBindBuffer(GL_UNIFORM_BUFFER, 0);
            glBindBuffer(GL_SHADER_STORAGE_BUFFER, Buffer_uid_43);
        }
    }

    NV_CHECK_INIT(Context_uid_26);
    FreeCachedMemory();
}

NV_REPLAY_END_FRAME_SETUP()
