//-------------------------------------------------------------------------------
// File: Resources\OpenGLReplay.h
//
// Copyright (c) NVIDIA Corporation.  All rights reserved.
//-------------------------------------------------------------------------------

#pragma once

#if defined(WIN32)
#include <GL/glew.h>
#else
#ifdef NV_USE_OPENGL
#include "GL/gl.h"
#include "GL/glext.h"
#else
#include "nvgles.h"
#endif
#endif

enum NoErrorMode
{
    ApplicationDefault,
    Enable,
    Disable
};

extern NoErrorMode noErrorMode;

#ifdef NV_USE_OPENGL
void* GLReplay_MapBuffer(GLuint buffer, GLenum target, GLenum access);
void* GLReplay_MapNamedBuffer(GLuint buffer, GLenum access);
void* GLReplay_MapNamedBufferEXT(GLuint buffer, GLenum access);
void* GLReplay_MapNamedBufferRange(GLuint buffer, GLintptr offset, GLsizeiptr length, GLbitfield access);
void* GLReplay_MapNamedBufferRangeEXT(GLuint buffer, GLintptr offset, GLsizeiptr length, GLbitfield access);
void GLReplay_UnmapNamedBuffer(GLuint buffer);
void GLReplay_UnmapNamedBufferEXT(GLuint buffer);
void GLReplay_BufferStorage(GLuint buffer, GLenum target, GLsizeiptr size, const GLvoid* data, GLbitfield flags);
void GLReplay_NamedBufferStorage(GLuint buffer, GLsizeiptr size, const GLvoid* data, GLbitfield flags);
void GLReplay_NamedBufferStorageEXT(GLuint buffer, GLsizeiptr size, const GLvoid* data, GLbitfield flags);
#endif

void* GLReplay_MapBufferOES(GLuint buffer, GLenum target, GLenum access);
void* GLReplay_MapBufferRange(GLuint buffer, GLenum target, GLintptr offset, GLsizeiptr length, GLbitfield access);
void GLReplay_UnmapBuffer(GLuint buffer, GLenum target);
void GLReplay_UnmapBufferOES(GLuint buffer, GLenum target);
void GLReplay_BufferStorageEXT(GLuint buffer, GLenum target, GLsizeiptr size, const GLvoid* data, GLbitfield flags);