//-----------------------------------------------------------------------------
// Generated with NVIDIA Nsight Graphics 2021.1.1.0
// 
// File: Resources00.cpp
// 
//-----------------------------------------------------------------------------

#include <vector>
#include <GL/glew.h>
#include <GL/wglew.h>
#include <GL/wglext.h>

#include "OpenGLReplay.h"
#include "OpenGLHelpers.h"
#include "WGLHelpers.h"
#include "Helpers.h"
#include "ReplayHelpers.h"
#include "Resources.h"
#include "WindowSystem.h"

NV_REPLAY_BEGIN_RESOURCE_INIT()

//-----------------------------------------------------------------------------
// CreateResources00
//-----------------------------------------------------------------------------
void CreateResources00()
{
    BEGIN_DATA_SCOPE_FUNCTION();

    // Create Context_uid_26 and its staging resource
    {
        BEGIN_DATA_SCOPE();

        Context tempContext = wglCreateContext(hdc_000000001A010C7C);
        NV_EXEC_GL(wglMakeCurrent(hdc_000000001A010C7C, tempContext));
        NV_THROW_IF(glewInit() != GLEW_OK, "Failed to initialize glew");

        static int int_temp_1[15] = { 
            WGL_CONTEXT_MAJOR_VERSION_ARB, 4, WGL_CONTEXT_MINOR_VERSION_ARB, 6, WGL_CONTEXT_PROFILE_MASK_ARB, WGL_CONTEXT_CORE_PROFILE_BIT_ARB, WGL_CONTEXT_RELEASE_BEHAVIOR_ARB, WGL_CONTEXT_RELEASE_BEHAVIOR_FLUSH_ARB, 
            WGL_CONTEXT_RESET_NOTIFICATION_STRATEGY_ARB, WGL_NO_RESET_NOTIFICATION_ARB, WGL_CONTEXT_OPENGL_NO_ERROR_ARB, 0, WGL_CONTEXT_FLAGS_ARB, 0, 0 };

        if (forceDebug)
        {
            BEGIN_DATA_SCOPE();

            int_temp_1[13] |= WGL_CONTEXT_DEBUG_BIT_ARB;
        }

        if (noErrorMode == NoErrorMode::Enable)
        {
            BEGIN_DATA_SCOPE();

            int_temp_1[11] = 1;
        }
        else if (noErrorMode == NoErrorMode::Disable)
        {
            BEGIN_DATA_SCOPE();

            int_temp_1[11] = 0;
        }

        Context_uid_26 = wglCreateContextAttribsARB(hdc_000000001A010C7C, NULL, int_temp_1);

        // Create Context_uid_26_Staging
        {
            BEGIN_DATA_SCOPE();

            Context_uid_26_Staging = wglCreateContextAttribsARB(hdc_000000001A010C7C, Context_uid_26, int_temp_1);
            NV_EXEC_GL(wglMakeCurrent(hdc_000000001A010C7C, Context_uid_26_Staging));
            NV_EXEC_GL(glPixelStorei(GL_UNPACK_ALIGNMENT, 1));
        }

        NV_EXEC_GL(wglMakeCurrent(hdc_000000001A010C7C, Context_uid_26));
        NV_EXEC_GL(wglDeleteContext(tempContext));

        // Debug Context Setup
        if (forceDebug)
        {
            BEGIN_DATA_SCOPE();

            NV_EXEC_GL(glEnable(GL_DEBUG_OUTPUT_SYNCHRONOUS));
            NV_EXEC_GL(glDebugMessageCallback(DebugCallback, nullptr));
            NV_EXEC_GL(glDebugMessageControl(GL_DONT_CARE, GL_DEBUG_TYPE_ERROR, GL_DONT_CARE, 0, 0, GL_MAP_READ_BIT));
            NV_EXEC_GL(glDebugMessageControl(GL_DONT_CARE, GL_DEBUG_TYPE_DEPRECATED_BEHAVIOR, GL_DONT_CARE, 0, 0, GL_MAP_READ_BIT));
            NV_EXEC_GL(glDebugMessageControl(GL_DONT_CARE, GL_DEBUG_TYPE_UNDEFINED_BEHAVIOR, GL_DONT_CARE, 0, 0, GL_MAP_READ_BIT));
            NV_EXEC_GL(glDebugMessageControl(GL_DONT_CARE, GL_DEBUG_TYPE_PORTABILITY, GL_DONT_CARE, 0, 0, GL_MAP_READ_BIT));
            NV_EXEC_GL(glDebugMessageControl(GL_DONT_CARE, GL_DEBUG_TYPE_PERFORMANCE, GL_DONT_CARE, 0, 0, GL_ZERO));
            NV_EXEC_GL(glDebugMessageControl(GL_DONT_CARE, GL_DEBUG_TYPE_MARKER, GL_DONT_CARE, 0, 0, GL_ZERO));
            NV_EXEC_GL(glDebugMessageControl(GL_DONT_CARE, GL_DEBUG_TYPE_PUSH_GROUP, GL_DONT_CARE, 0, 0, GL_ZERO));
            NV_EXEC_GL(glDebugMessageControl(GL_DONT_CARE, GL_DEBUG_TYPE_POP_GROUP, GL_DONT_CARE, 0, 0, GL_ZERO));
            NV_EXEC_GL(glDebugMessageControl(GL_DONT_CARE, GL_DEBUG_TYPE_OTHER, GL_DONT_CARE, 0, 0, GL_ZERO));
        }
    }

    // Switch to staging context
    NV_EXEC_GL(glFinish());
    MakeCurrent(hdc_000000001A010C7C, Context_uid_26_Staging);

    // Create Buffer_uid_30
    NV_EXEC_GL(glGenBuffers(1, &Buffer_uid_30));

    // Create Buffer_uid_31
    NV_EXEC_GL(glGenBuffers(1, &Buffer_uid_31));

    // Create Texture_uid_32 and its staging resources
    NV_EXEC_GL(glGenTextures(1, &Texture_uid_32));
    NV_EXEC_GL(glActiveTexture(GL_TEXTURE0));
    NV_EXEC_GL(glBindTexture(GL_TEXTURE_2D, Texture_uid_32));
    NV_EXEC_GL(glGenTextures(1, &Texture_uid_32_Staging));
    NV_EXEC_GL(glActiveTexture(GL_TEXTURE0));
    NV_EXEC_GL(glBindTexture(GL_TEXTURE_2D, Texture_uid_32_Staging));
    NV_EXEC_GL(glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR));
    NV_EXEC_GL(glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE));
    NV_EXEC_GL(glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE));
    NV_EXEC_GL(glTexStorage2D(GL_TEXTURE_2D, 1, GL_RGBA32F, 1280, 720));
    NV_EXEC_GL(glTexSubImage2D(GL_TEXTURE_2D, 0u, 0, 0, 1280, 720, GL_RGBA, GL_FLOAT, NV_GET_RESOURCE(GLvoid*, 5)));
    NV_EXEC_GL(glObjectLabel(GL_TEXTURE, Texture_uid_32_Staging, -1, "NvdaReplayerPrivate"));
    NV_EXEC_GL(glGenFramebuffers(1, &Texture_uid_32_Staging_Read_Framebuffer));
    NV_EXEC_GL(glBindFramebuffer(GL_FRAMEBUFFER, Texture_uid_32_Staging_Read_Framebuffer));
    NV_EXEC_GL(glObjectLabel(GL_FRAMEBUFFER, Texture_uid_32_Staging_Read_Framebuffer, -1, "NvdaReplayerPrivate"));
    NV_EXEC_GL(glGenFramebuffers(1, &Texture_uid_32_Staging_Draw_Framebuffer));
    NV_EXEC_GL(glBindFramebuffer(GL_FRAMEBUFFER, Texture_uid_32_Staging_Draw_Framebuffer));
    NV_EXEC_GL(glObjectLabel(GL_FRAMEBUFFER, Texture_uid_32_Staging_Draw_Framebuffer, -1, "NvdaReplayerPrivate"));

    // Create Shader_uid_34
    Shader_uid_34 = glCreateShader(GL_VERTEX_SHADER);

    // Create Shader_uid_35
    Shader_uid_35 = glCreateShader(GL_FRAGMENT_SHADER);

    // Create Program_uid_36
    Program_uid_36 = glCreateProgram();

    // Create Shader_uid_37
    Shader_uid_37 = glCreateShader(GL_COMPUTE_SHADER);

    // Create Program_uid_38
    Program_uid_38 = glCreateProgram();

    // Create Buffer_uid_39
    NV_EXEC_GL(glGenBuffers(1, &Buffer_uid_39));

    // Create Buffer_uid_40 and its staging resource
    NV_EXEC_GL(glGenBuffers(1, &Buffer_uid_40));
    NV_EXEC_GL(glGenBuffers(1, &Buffer_uid_40_Staging));
    NV_EXEC_GL(glBindBuffer(GL_COPY_WRITE_BUFFER, Buffer_uid_40_Staging));
    NV_EXEC_GL(glBufferData(GL_COPY_WRITE_BUFFER, 424800, NV_GET_RESOURCE(GLvoid*, 6), GL_STREAM_READ));
    NV_EXEC_GL(glObjectLabel(GL_BUFFER, Buffer_uid_40_Staging, -1, "NvdaReplayerPrivate"));

    // Create Buffer_uid_41
    NV_EXEC_GL(glGenBuffers(1, &Buffer_uid_41));

    // Create Buffer_uid_42 and its staging resource
    NV_EXEC_GL(glGenBuffers(1, &Buffer_uid_42));
    NV_EXEC_GL(glGenBuffers(1, &Buffer_uid_42_Staging));
    NV_EXEC_GL(glBindBuffer(GL_COPY_WRITE_BUFFER, Buffer_uid_42_Staging));
    NV_EXEC_GL(glBufferData(GL_COPY_WRITE_BUFFER, 48, NV_GET_RESOURCE(GLvoid*, 7), GL_STREAM_READ));
    NV_EXEC_GL(glObjectLabel(GL_BUFFER, Buffer_uid_42_Staging, -1, "NvdaReplayerPrivate"));

    // Create Buffer_uid_43 and its staging resource
    NV_EXEC_GL(glGenBuffers(1, &Buffer_uid_43));
    NV_EXEC_GL(glGenBuffers(1, &Buffer_uid_43_Staging));
    NV_EXEC_GL(glBindBuffer(GL_COPY_WRITE_BUFFER, Buffer_uid_43_Staging));
    NV_EXEC_GL(glBufferData(GL_COPY_WRITE_BUFFER, 288336, NV_GET_RESOURCE(GLvoid*, 8), GL_STREAM_READ));
    NV_EXEC_GL(glObjectLabel(GL_BUFFER, Buffer_uid_43_Staging, -1, "NvdaReplayerPrivate"));

    // Switch to rendering context
    NV_EXEC_GL(glFinish());
    MakeCurrent(hdc_000000001A010C7C, Context_uid_26);

    // Create TransformFeedback_uid_27
    TransformFeedback_uid_27 = 0;

    // Create VertexArray_uid_28
    VertexArray_uid_28 = 0;

    // Create VertexArray_uid_29
    NV_EXEC_GL(glGenVertexArrays(1, &VertexArray_uid_29));
}

//-----------------------------------------------------------------------------
// OnBeforeWinResourcesInit00
//-----------------------------------------------------------------------------
void OnBeforeWinResourcesInit00()
{
    BEGIN_DATA_SCOPE_FUNCTION();

}

//-----------------------------------------------------------------------------
// CreateWinResources00
//-----------------------------------------------------------------------------
void CreateWinResources00()
{
    BEGIN_DATA_SCOPE_FUNCTION();

    // Create hwnd_0000000000030628
    {
        BEGIN_DATA_SCOPE();

        NV_THROW_IF(!RegisterReplayerWindowClass(currentInstance, CS_BYTEALIGNCLIENT | CS_OWNDC), "Failed to register window class");
        const uint32_t x = 0u;
        const uint32_t y = 0u;
        const uint32_t Width = 1280u;
        const uint32_t Height = 720u;
        const DWORD Style = WS_BORDER | WS_DLGFRAME | WS_OVERLAPPED | WS_SYSMENU | WS_TILED | WS_VISIBLE;
        const DWORD ExtendedStyle = 0;
        PROCESS_DPI_AWARENESS DpiAwareness = PROCESS_DPI_UNAWARE;
        hwnd_0000000000030628 = CreateReplayerWindow(currentInstance, nullptr, x, y, Width, Height, Style, ExtendedStyle, DpiAwareness);
        NV_THROW_IF(!hwnd_0000000000030628, "Failed to create replayer window");
    }

    // Create hdc_000000001A010C7C
    {
        BEGIN_DATA_SCOPE();

        hdc_000000001A010C7C = GetWindowDC(hwnd_0000000000030628);
        NV_THROW_IF(!hdc_000000001A010C7C, "Failed to retrieve window device context");
    }
}

//-----------------------------------------------------------------------------
// OnAfterWinResourcesInit00
//-----------------------------------------------------------------------------
void OnAfterWinResourcesInit00()
{
    BEGIN_DATA_SCOPE_FUNCTION();

}

//-----------------------------------------------------------------------------
// ReleaseResources00
//-----------------------------------------------------------------------------
void ReleaseResources00()
{
    BEGIN_DATA_SCOPE_FUNCTION();

    // Switch to staging context
    NV_EXEC_GL(glFinish());
    MakeCurrent(hdc_000000001A010C7C, Context_uid_26_Staging);

    // Release Buffer_uid_43 and its staging resource
    NV_EXEC_GL(glDeleteBuffers(1, &Buffer_uid_43_Staging));
    NV_EXEC_GL(glDeleteBuffers(1, &Buffer_uid_43));

    // Release Buffer_uid_42 and its staging resource
    NV_EXEC_GL(glDeleteBuffers(1, &Buffer_uid_42_Staging));
    NV_EXEC_GL(glDeleteBuffers(1, &Buffer_uid_42));

    // Release Buffer_uid_41
    NV_EXEC_GL(glDeleteBuffers(1, &Buffer_uid_41));

    // Release Buffer_uid_40 and its staging resource
    NV_EXEC_GL(glDeleteBuffers(1, &Buffer_uid_40_Staging));
    NV_EXEC_GL(glDeleteBuffers(1, &Buffer_uid_40));

    // Release Buffer_uid_39
    NV_EXEC_GL(glDeleteBuffers(1, &Buffer_uid_39));

    // Release Program_uid_38
    NV_EXEC_GL(glDeleteProgram(Program_uid_38));

    // Release Shader_uid_37
    NV_EXEC_GL(glDeleteShader(Shader_uid_37));

    // Release Program_uid_36
    NV_EXEC_GL(glDeleteProgram(Program_uid_36));

    // Release Shader_uid_35
    NV_EXEC_GL(glDeleteShader(Shader_uid_35));

    // Release Shader_uid_34
    NV_EXEC_GL(glDeleteShader(Shader_uid_34));

    // Release Texture_uid_32 and its staging resources
    NV_EXEC_GL(glDeleteTextures(1, &Texture_uid_32));
    NV_EXEC_GL(glDeleteTextures(1, &Texture_uid_32_Staging));
    NV_EXEC_GL(glDeleteFramebuffers(1, &Texture_uid_32_Staging_Read_Framebuffer));
    NV_EXEC_GL(glDeleteFramebuffers(1, &Texture_uid_32_Staging_Draw_Framebuffer));

    // Release Buffer_uid_31
    NV_EXEC_GL(glDeleteBuffers(1, &Buffer_uid_31));

    // Release Buffer_uid_30
    NV_EXEC_GL(glDeleteBuffers(1, &Buffer_uid_30));

    // Switch to rendering context
    NV_EXEC_GL(glFinish());
    MakeCurrent(hdc_000000001A010C7C, Context_uid_26);

    // Release VertexArray_uid_29
    NV_EXEC_GL(glDeleteVertexArrays(1, &VertexArray_uid_29));

    // Release TransformFeedback_uid_27
    NV_EXEC_GL(glDeleteTransformFeedbacks(1, &TransformFeedback_uid_27));

    // Release Context_uid_26 and its staging resource
    wglDeleteContext(Context_uid_26);
    wglDeleteContext(Context_uid_26_Staging);
}

//-----------------------------------------------------------------------------
// ReleaseWinResources00
//-----------------------------------------------------------------------------
void ReleaseWinResources00()
{
    BEGIN_DATA_SCOPE_FUNCTION();

    // Release hwnd_0000000000030628
    DestroyWindow(hwnd_0000000000030628);
}

//-----------------------------------------------------------------------------
// OnAfterWinResourcesReleased00
//-----------------------------------------------------------------------------
void OnAfterWinResourcesReleased00()
{
    BEGIN_DATA_SCOPE_FUNCTION();

}

//-----------------------------------------------------------------------------
// Captured Resources
//-----------------------------------------------------------------------------
Uniform Uniform_prog_3_loc_0;
ShaderStorageBlock ShaderStorageBlock_prog_5_loc_0;
Uniform Uniform_prog_5_loc_0;
ShaderStorageBlock ShaderStorageBlock_prog_5_loc_1;
Uniform Uniform_prog_5_loc_1;
ShaderStorageBlock ShaderStorageBlock_prog_5_loc_2;
ShaderStorageBlock ShaderStorageBlock_prog_5_loc_3;
ShaderStorageBlock ShaderStorageBlock_prog_5_loc_4;
Context Context_uid_26;
TransformFeedback TransformFeedback_uid_27;
VertexArray VertexArray_uid_28;
VertexArray VertexArray_uid_29;
Buffer Buffer_uid_30;
Buffer Buffer_uid_31;
Texture Texture_uid_32;
Shader Shader_uid_34;
Shader Shader_uid_35;
Program Program_uid_36;
Shader Shader_uid_37;
Program Program_uid_38;
Buffer Buffer_uid_39;
Buffer Buffer_uid_40;
Buffer Buffer_uid_41;
Buffer Buffer_uid_42;
Buffer Buffer_uid_43;
HWND hwnd_0000000000030628;
HDC hdc_000000001A010C7C;
Context Context_uid_26_Staging;
Buffer Buffer_uid_43_Staging;
Buffer Buffer_uid_40_Staging;
Buffer Buffer_uid_42_Staging;
Texture Texture_uid_32_Staging;
FrameBuffer Texture_uid_32_Staging_Read_Framebuffer;
FrameBuffer Texture_uid_32_Staging_Draw_Framebuffer;
NV_REPLAY_END_RESOURCE_INIT()
